/**
 * This class was generated from a set of XML constraints
 *   by the Enhydra Zeus XML Data Binding Framework. All
 *   source code in this file is constructed specifically
 *   to work with other Zeus-generated classes. If you
 *   modify this file by hand, you run the risk of breaking
 *   this interoperation, as well as introducing errors in
 *   source code compilation.
 *
 * * * * * MODIFY THIS FILE AT YOUR OWN RISK * * * * *
 *
 * To find out more about the Enhydra Zeus framework, you
 *   can point your browser at <http://zeus.enhydra.org>
 *   where you can download releases, join and discuss Zeus
 *   on user and developer mailing lists, and access source
 *   code. Please report any bugs through that website.
 */
package org.objectweb.jonas_ejb.deployment.xml;

// Global Implementation Import Statements
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Reader;
import java.io.Writer;
import org.xml.sax.Attributes;
import org.xml.sax.EntityResolver;
import org.xml.sax.ErrorHandler;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.XMLReaderFactory;

// Local Implementation Import Statements
import java.util.Iterator;
import java.util.List;
import java.util.LinkedList;

public class EntityImpl extends DefaultHandler implements Unmarshallable, Entity {

    private Description description;
    private DisplayName displayName;
    private SmallIcon smallIcon;
    private LargeIcon largeIcon;
    private EjbName ejbName;
    private Home home;
    private Remote remote;
    private LocalHome localHome;
    private Local local;
    private EjbClass ejbClass;
    private PersistenceType persistenceType;
    private PrimKeyClass primKeyClass;
    private Reentrant reentrant;
    private CmpVersion cmpVersion;
    private AbstractSchemaName abstractSchemaName;
    private List cmpFieldList;
    private PrimkeyField primkeyField;
    private List envEntryList;
    private List ejbRefList;
    private List ejbLocalRefList;
    private List securityRoleRefList;
    private SecurityIdentity securityIdentity;
    private List resourceRefList;
    private List resourceEnvRefList;
    private List queryList;
    private String id;
    private boolean zeus_idSet;

    /** The current node in unmarshalling */
    private Unmarshallable zeus_currentUNode;

    /** The parent node in unmarshalling */
    private Unmarshallable zeus_parentUNode;

    /** Whether this node has been handled */
    private boolean zeus_thisNodeHandled = false;

    /** The EntityResolver for SAX parsing to use */
    private static EntityResolver entityResolver;

    /** The ErrorHandler for SAX parsing to use */
    private static ErrorHandler errorHandler;

    public EntityImpl() {
        cmpFieldList = new LinkedList();
        envEntryList = new LinkedList();
        ejbRefList = new LinkedList();
        ejbLocalRefList = new LinkedList();
        securityRoleRefList = new LinkedList();
        resourceRefList = new LinkedList();
        resourceEnvRefList = new LinkedList();
        queryList = new LinkedList();
        zeus_idSet = false;
    }

    public Description getDescription() {
        return description;
    }

    public void setDescription(Description description) {
        this.description = description;
    }

    public DisplayName getDisplayName() {
        return displayName;
    }

    public void setDisplayName(DisplayName displayName) {
        this.displayName = displayName;
    }

    public SmallIcon getSmallIcon() {
        return smallIcon;
    }

    public void setSmallIcon(SmallIcon smallIcon) {
        this.smallIcon = smallIcon;
    }

    public LargeIcon getLargeIcon() {
        return largeIcon;
    }

    public void setLargeIcon(LargeIcon largeIcon) {
        this.largeIcon = largeIcon;
    }

    public EjbName getEjbName() {
        return ejbName;
    }

    public void setEjbName(EjbName ejbName) {
        this.ejbName = ejbName;
    }

    public Home getHome() {
        return home;
    }

    public void setHome(Home home) {
        this.home = home;
    }

    public Remote getRemote() {
        return remote;
    }

    public void setRemote(Remote remote) {
        this.remote = remote;
    }

    public LocalHome getLocalHome() {
        return localHome;
    }

    public void setLocalHome(LocalHome localHome) {
        this.localHome = localHome;
    }

    public Local getLocal() {
        return local;
    }

    public void setLocal(Local local) {
        this.local = local;
    }

    public EjbClass getEjbClass() {
        return ejbClass;
    }

    public void setEjbClass(EjbClass ejbClass) {
        this.ejbClass = ejbClass;
    }

    public PersistenceType getPersistenceType() {
        return persistenceType;
    }

    public void setPersistenceType(PersistenceType persistenceType) {
        this.persistenceType = persistenceType;
    }

    public PrimKeyClass getPrimKeyClass() {
        return primKeyClass;
    }

    public void setPrimKeyClass(PrimKeyClass primKeyClass) {
        this.primKeyClass = primKeyClass;
    }

    public Reentrant getReentrant() {
        return reentrant;
    }

    public void setReentrant(Reentrant reentrant) {
        this.reentrant = reentrant;
    }

    public CmpVersion getCmpVersion() {
        return cmpVersion;
    }

    public void setCmpVersion(CmpVersion cmpVersion) {
        this.cmpVersion = cmpVersion;
    }

    public AbstractSchemaName getAbstractSchemaName() {
        return abstractSchemaName;
    }

    public void setAbstractSchemaName(AbstractSchemaName abstractSchemaName) {
        this.abstractSchemaName = abstractSchemaName;
    }

    public List getCmpFieldList() {
        return cmpFieldList;
    }

    public void setCmpFieldList(List cmpFieldList) {
        this.cmpFieldList = cmpFieldList;
    }

    public void addCmpField(CmpField cmpField) {
        cmpFieldList.add(cmpField);
    }

    public void removeCmpField(CmpField cmpField) {
        cmpFieldList.remove(cmpField);
    }

    public PrimkeyField getPrimkeyField() {
        return primkeyField;
    }

    public void setPrimkeyField(PrimkeyField primkeyField) {
        this.primkeyField = primkeyField;
    }

    public List getEnvEntryList() {
        return envEntryList;
    }

    public void setEnvEntryList(List envEntryList) {
        this.envEntryList = envEntryList;
    }

    public void addEnvEntry(EnvEntry envEntry) {
        envEntryList.add(envEntry);
    }

    public void removeEnvEntry(EnvEntry envEntry) {
        envEntryList.remove(envEntry);
    }

    public List getEjbRefList() {
        return ejbRefList;
    }

    public void setEjbRefList(List ejbRefList) {
        this.ejbRefList = ejbRefList;
    }

    public void addEjbRef(EjbRef ejbRef) {
        ejbRefList.add(ejbRef);
    }

    public void removeEjbRef(EjbRef ejbRef) {
        ejbRefList.remove(ejbRef);
    }

    public List getEjbLocalRefList() {
        return ejbLocalRefList;
    }

    public void setEjbLocalRefList(List ejbLocalRefList) {
        this.ejbLocalRefList = ejbLocalRefList;
    }

    public void addEjbLocalRef(EjbLocalRef ejbLocalRef) {
        ejbLocalRefList.add(ejbLocalRef);
    }

    public void removeEjbLocalRef(EjbLocalRef ejbLocalRef) {
        ejbLocalRefList.remove(ejbLocalRef);
    }

    public List getSecurityRoleRefList() {
        return securityRoleRefList;
    }

    public void setSecurityRoleRefList(List securityRoleRefList) {
        this.securityRoleRefList = securityRoleRefList;
    }

    public void addSecurityRoleRef(SecurityRoleRef securityRoleRef) {
        securityRoleRefList.add(securityRoleRef);
    }

    public void removeSecurityRoleRef(SecurityRoleRef securityRoleRef) {
        securityRoleRefList.remove(securityRoleRef);
    }

    public SecurityIdentity getSecurityIdentity() {
        return securityIdentity;
    }

    public void setSecurityIdentity(SecurityIdentity securityIdentity) {
        this.securityIdentity = securityIdentity;
    }

    public List getResourceRefList() {
        return resourceRefList;
    }

    public void setResourceRefList(List resourceRefList) {
        this.resourceRefList = resourceRefList;
    }

    public void addResourceRef(ResourceRef resourceRef) {
        resourceRefList.add(resourceRef);
    }

    public void removeResourceRef(ResourceRef resourceRef) {
        resourceRefList.remove(resourceRef);
    }

    public List getResourceEnvRefList() {
        return resourceEnvRefList;
    }

    public void setResourceEnvRefList(List resourceEnvRefList) {
        this.resourceEnvRefList = resourceEnvRefList;
    }

    public void addResourceEnvRef(ResourceEnvRef resourceEnvRef) {
        resourceEnvRefList.add(resourceEnvRef);
    }

    public void removeResourceEnvRef(ResourceEnvRef resourceEnvRef) {
        resourceEnvRefList.remove(resourceEnvRef);
    }

    public List getQueryList() {
        return queryList;
    }

    public void setQueryList(List queryList) {
        this.queryList = queryList;
    }

    public void addQuery(Query query) {
        queryList.add(query);
    }

    public void removeQuery(Query query) {
        queryList.remove(query);
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
        zeus_idSet = true;
    }

    public void marshal(File file) throws IOException {
        // Delegate to the marshal(Writer) method
        marshal(new FileWriter(file));
    }

    public void marshal(OutputStream outputStream) throws IOException {
        // Delegate to the marshal(Writer) method
        marshal(new OutputStreamWriter(outputStream));
    }

    public void marshal(Writer writer) throws IOException {
        // Write out the XML declaration
        writer.write("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n\n");

        // Now start the recursive writing
        writeXMLRepresentation(writer, "");

        // Close up
        writer.flush();
        writer.close();
    }

    protected void writeXMLRepresentation(Writer writer,
                                          String indent)
        throws IOException {

        writer.write(indent);
        writer.write("<entity");

        // Handle attributes (if needed)
        if (zeus_idSet) {
            writer.write(" id=\"");
            writer.write(escapeAttributeValue(id));
            writer.write("\"");
        }
        writer.write(">");
        writer.write("\n");

        // Handle child elements
        if (description != null) {
            ((DescriptionImpl)description).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (displayName != null) {
            ((DisplayNameImpl)displayName).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (smallIcon != null) {
            ((SmallIconImpl)smallIcon).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (largeIcon != null) {
            ((LargeIconImpl)largeIcon).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (ejbName != null) {
            ((EjbNameImpl)ejbName).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (home != null) {
            ((HomeImpl)home).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (remote != null) {
            ((RemoteImpl)remote).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (localHome != null) {
            ((LocalHomeImpl)localHome).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (local != null) {
            ((LocalImpl)local).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (ejbClass != null) {
            ((EjbClassImpl)ejbClass).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (persistenceType != null) {
            ((PersistenceTypeImpl)persistenceType).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (primKeyClass != null) {
            ((PrimKeyClassImpl)primKeyClass).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (reentrant != null) {
            ((ReentrantImpl)reentrant).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (cmpVersion != null) {
            ((CmpVersionImpl)cmpVersion).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (abstractSchemaName != null) {
            ((AbstractSchemaNameImpl)abstractSchemaName).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        for (Iterator i=cmpFieldList.iterator(); i.hasNext(); ) {
            CmpFieldImpl cmpField = (CmpFieldImpl)i.next();
            cmpField.writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }
        if (primkeyField != null) {
            ((PrimkeyFieldImpl)primkeyField).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        for (Iterator i=envEntryList.iterator(); i.hasNext(); ) {
            EnvEntryImpl envEntry = (EnvEntryImpl)i.next();
            envEntry.writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }
        for (Iterator i=ejbRefList.iterator(); i.hasNext(); ) {
            EjbRefImpl ejbRef = (EjbRefImpl)i.next();
            ejbRef.writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }
        for (Iterator i=ejbLocalRefList.iterator(); i.hasNext(); ) {
            EjbLocalRefImpl ejbLocalRef = (EjbLocalRefImpl)i.next();
            ejbLocalRef.writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }
        for (Iterator i=securityRoleRefList.iterator(); i.hasNext(); ) {
            SecurityRoleRefImpl securityRoleRef = (SecurityRoleRefImpl)i.next();
            securityRoleRef.writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }
        if (securityIdentity != null) {
            ((SecurityIdentityImpl)securityIdentity).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        for (Iterator i=resourceRefList.iterator(); i.hasNext(); ) {
            ResourceRefImpl resourceRef = (ResourceRefImpl)i.next();
            resourceRef.writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }
        for (Iterator i=resourceEnvRefList.iterator(); i.hasNext(); ) {
            ResourceEnvRefImpl resourceEnvRef = (ResourceEnvRefImpl)i.next();
            resourceEnvRef.writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }
        for (Iterator i=queryList.iterator(); i.hasNext(); ) {
            QueryImpl query = (QueryImpl)i.next();
            query.writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }
        writer.write(indent);
        writer.write("</entity>\n");
    }

    private String escapeAttributeValue(String attributeValue) {
        String returnValue = attributeValue;
        for (int i = 0; i < returnValue.length(); i++) {
            char ch = returnValue.charAt(i);
            if (ch == '"') {
                returnValue = new StringBuffer()
                    .append(returnValue.substring(0, i))
                    .append("&quot;")
                    .append(returnValue.substring(i+1))
                    .toString();
            }
        }
        return returnValue;
    }

    /**
     * <p>
     *  This sets a SAX <code>EntityResolver</code> for this unmarshalling process.
     * </p>
     *
     * @param resolver the entity resolver to use.
     */
    public static void setEntityResolver(EntityResolver resolver) {
        entityResolver = resolver;
    }

    /**
     * <p>
     *  This sets a SAX <code>ErrorHandler</code> for this unmarshalling process.
     * </p>
     *
     * @param handler the entity resolver to use.
     */
    public static void setErrorHandler(ErrorHandler handler) {
        errorHandler = handler;
    }

    public static Entity unmarshal(File file) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new FileReader(file));
    }

    public static Entity unmarshal(File file, boolean validate) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new FileReader(file), validate);
    }

    public static Entity unmarshal(InputStream inputStream) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new InputStreamReader(inputStream));
    }

    public static Entity unmarshal(InputStream inputStream, boolean validate) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new InputStreamReader(inputStream), validate);
    }

    public static Entity unmarshal(Reader reader) throws IOException {
        // Delegate with default validation value
        return unmarshal(reader, false);
    }

    public static Entity unmarshal(Reader reader, boolean validate) throws IOException {
        EntityImpl entity = new EntityImpl();
        entity.setCurrentUNode(entity);
        entity.setParentUNode(null);
        // Load the XML parser
        XMLReader parser = null;
        String parserClass = System.getProperty("org.xml.sax.driver",
            "org.apache.xerces.parsers.SAXParser");
        try {
            parser = XMLReaderFactory.createXMLReader(parserClass);

            // Set entity resolver, if needed
            if (entityResolver != null) {
                parser.setEntityResolver(entityResolver);
            }

            // Set error handler, if needed
            if (errorHandler != null) {
                parser.setErrorHandler(errorHandler);
            }

            // Register content handler
            parser.setContentHandler(entity);
        } catch (SAXException e) {
            throw new IOException("Could not load XML parser: " + 
                e.getMessage());
        }

        InputSource inputSource = new InputSource(reader);
        try {
            parser.setFeature("http://xml.org/sax/features/validation", new Boolean(validate).booleanValue());
            parser.parse(inputSource);
        } catch (SAXException e) {
            throw new IOException("Error parsing XML document: " + 
                e.getMessage());
        }

        // Return the resultant object
        return entity;
    }

    public Unmarshallable getParentUNode() {
        return zeus_parentUNode;
    }

    public void setParentUNode(Unmarshallable parentUNode) {
        this.zeus_parentUNode = parentUNode;
    }

    public Unmarshallable getCurrentUNode() {
        return zeus_currentUNode;
    }

    public void setCurrentUNode(Unmarshallable currentUNode) {
        this.zeus_currentUNode = currentUNode;
    }

    public void startElement(String namespaceURI, String localName,
                             String qName, Attributes atts)
        throws SAXException {

        // Feed this to the correct ContentHandler
        Unmarshallable current = getCurrentUNode();
        if (current != this) {
            current.startElement(namespaceURI, localName, qName, atts);
            return;
        }

        // See if we handle, or we delegate
        if ((localName.equals("entity")) && (!zeus_thisNodeHandled)) {
            // Handle ourselves
            for (int i=0, len=atts.getLength(); i<len; i++) {
                String attName= atts.getLocalName(i);
                String attValue = atts.getValue(i);
                if (attName.equals("id")) {
                    setId(attValue);
                }
            }
            zeus_thisNodeHandled = true;
            return;
        } else {
            // Delegate handling
            if (localName.equals("description")) {
                DescriptionImpl description = new DescriptionImpl();
                current = getCurrentUNode();
                description.setParentUNode(current);
                description.setCurrentUNode(description);
                this.setCurrentUNode(description);
                description.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.description = description;
                return;
            }
            if (localName.equals("display-name")) {
                DisplayNameImpl displayName = new DisplayNameImpl();
                current = getCurrentUNode();
                displayName.setParentUNode(current);
                displayName.setCurrentUNode(displayName);
                this.setCurrentUNode(displayName);
                displayName.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.displayName = displayName;
                return;
            }
            if (localName.equals("small-icon")) {
                SmallIconImpl smallIcon = new SmallIconImpl();
                current = getCurrentUNode();
                smallIcon.setParentUNode(current);
                smallIcon.setCurrentUNode(smallIcon);
                this.setCurrentUNode(smallIcon);
                smallIcon.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.smallIcon = smallIcon;
                return;
            }
            if (localName.equals("large-icon")) {
                LargeIconImpl largeIcon = new LargeIconImpl();
                current = getCurrentUNode();
                largeIcon.setParentUNode(current);
                largeIcon.setCurrentUNode(largeIcon);
                this.setCurrentUNode(largeIcon);
                largeIcon.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.largeIcon = largeIcon;
                return;
            }
            if (localName.equals("ejb-name")) {
                EjbNameImpl ejbName = new EjbNameImpl();
                current = getCurrentUNode();
                ejbName.setParentUNode(current);
                ejbName.setCurrentUNode(ejbName);
                this.setCurrentUNode(ejbName);
                ejbName.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.ejbName = ejbName;
                return;
            }
            if (localName.equals("home")) {
                HomeImpl home = new HomeImpl();
                current = getCurrentUNode();
                home.setParentUNode(current);
                home.setCurrentUNode(home);
                this.setCurrentUNode(home);
                home.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.home = home;
                return;
            }
            if (localName.equals("remote")) {
                RemoteImpl remote = new RemoteImpl();
                current = getCurrentUNode();
                remote.setParentUNode(current);
                remote.setCurrentUNode(remote);
                this.setCurrentUNode(remote);
                remote.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.remote = remote;
                return;
            }
            if (localName.equals("local-home")) {
                LocalHomeImpl localHome = new LocalHomeImpl();
                current = getCurrentUNode();
                localHome.setParentUNode(current);
                localHome.setCurrentUNode(localHome);
                this.setCurrentUNode(localHome);
                localHome.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.localHome = localHome;
                return;
            }
            if (localName.equals("local")) {
                LocalImpl local = new LocalImpl();
                current = getCurrentUNode();
                local.setParentUNode(current);
                local.setCurrentUNode(local);
                this.setCurrentUNode(local);
                local.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.local = local;
                return;
            }
            if (localName.equals("ejb-class")) {
                EjbClassImpl ejbClass = new EjbClassImpl();
                current = getCurrentUNode();
                ejbClass.setParentUNode(current);
                ejbClass.setCurrentUNode(ejbClass);
                this.setCurrentUNode(ejbClass);
                ejbClass.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.ejbClass = ejbClass;
                return;
            }
            if (localName.equals("persistence-type")) {
                PersistenceTypeImpl persistenceType = new PersistenceTypeImpl();
                current = getCurrentUNode();
                persistenceType.setParentUNode(current);
                persistenceType.setCurrentUNode(persistenceType);
                this.setCurrentUNode(persistenceType);
                persistenceType.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.persistenceType = persistenceType;
                return;
            }
            if (localName.equals("prim-key-class")) {
                PrimKeyClassImpl primKeyClass = new PrimKeyClassImpl();
                current = getCurrentUNode();
                primKeyClass.setParentUNode(current);
                primKeyClass.setCurrentUNode(primKeyClass);
                this.setCurrentUNode(primKeyClass);
                primKeyClass.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.primKeyClass = primKeyClass;
                return;
            }
            if (localName.equals("reentrant")) {
                ReentrantImpl reentrant = new ReentrantImpl();
                current = getCurrentUNode();
                reentrant.setParentUNode(current);
                reentrant.setCurrentUNode(reentrant);
                this.setCurrentUNode(reentrant);
                reentrant.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.reentrant = reentrant;
                return;
            }
            if (localName.equals("cmp-version")) {
                CmpVersionImpl cmpVersion = new CmpVersionImpl();
                current = getCurrentUNode();
                cmpVersion.setParentUNode(current);
                cmpVersion.setCurrentUNode(cmpVersion);
                this.setCurrentUNode(cmpVersion);
                cmpVersion.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.cmpVersion = cmpVersion;
                return;
            }
            if (localName.equals("abstract-schema-name")) {
                AbstractSchemaNameImpl abstractSchemaName = new AbstractSchemaNameImpl();
                current = getCurrentUNode();
                abstractSchemaName.setParentUNode(current);
                abstractSchemaName.setCurrentUNode(abstractSchemaName);
                this.setCurrentUNode(abstractSchemaName);
                abstractSchemaName.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.abstractSchemaName = abstractSchemaName;
                return;
            }
            if (localName.equals("cmp-field")) {
                CmpFieldImpl cmpField = new CmpFieldImpl();
                current = getCurrentUNode();
                cmpField.setParentUNode(current);
                cmpField.setCurrentUNode(cmpField);
                this.setCurrentUNode(cmpField);
                cmpField.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                cmpFieldList.add(cmpField);
                return;
            }
            if (localName.equals("primkey-field")) {
                PrimkeyFieldImpl primkeyField = new PrimkeyFieldImpl();
                current = getCurrentUNode();
                primkeyField.setParentUNode(current);
                primkeyField.setCurrentUNode(primkeyField);
                this.setCurrentUNode(primkeyField);
                primkeyField.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.primkeyField = primkeyField;
                return;
            }
            if (localName.equals("env-entry")) {
                EnvEntryImpl envEntry = new EnvEntryImpl();
                current = getCurrentUNode();
                envEntry.setParentUNode(current);
                envEntry.setCurrentUNode(envEntry);
                this.setCurrentUNode(envEntry);
                envEntry.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                envEntryList.add(envEntry);
                return;
            }
            if (localName.equals("ejb-ref")) {
                EjbRefImpl ejbRef = new EjbRefImpl();
                current = getCurrentUNode();
                ejbRef.setParentUNode(current);
                ejbRef.setCurrentUNode(ejbRef);
                this.setCurrentUNode(ejbRef);
                ejbRef.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                ejbRefList.add(ejbRef);
                return;
            }
            if (localName.equals("ejb-local-ref")) {
                EjbLocalRefImpl ejbLocalRef = new EjbLocalRefImpl();
                current = getCurrentUNode();
                ejbLocalRef.setParentUNode(current);
                ejbLocalRef.setCurrentUNode(ejbLocalRef);
                this.setCurrentUNode(ejbLocalRef);
                ejbLocalRef.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                ejbLocalRefList.add(ejbLocalRef);
                return;
            }
            if (localName.equals("security-role-ref")) {
                SecurityRoleRefImpl securityRoleRef = new SecurityRoleRefImpl();
                current = getCurrentUNode();
                securityRoleRef.setParentUNode(current);
                securityRoleRef.setCurrentUNode(securityRoleRef);
                this.setCurrentUNode(securityRoleRef);
                securityRoleRef.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                securityRoleRefList.add(securityRoleRef);
                return;
            }
            if (localName.equals("security-identity")) {
                SecurityIdentityImpl securityIdentity = new SecurityIdentityImpl();
                current = getCurrentUNode();
                securityIdentity.setParentUNode(current);
                securityIdentity.setCurrentUNode(securityIdentity);
                this.setCurrentUNode(securityIdentity);
                securityIdentity.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.securityIdentity = securityIdentity;
                return;
            }
            if (localName.equals("resource-ref")) {
                ResourceRefImpl resourceRef = new ResourceRefImpl();
                current = getCurrentUNode();
                resourceRef.setParentUNode(current);
                resourceRef.setCurrentUNode(resourceRef);
                this.setCurrentUNode(resourceRef);
                resourceRef.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                resourceRefList.add(resourceRef);
                return;
            }
            if (localName.equals("resource-env-ref")) {
                ResourceEnvRefImpl resourceEnvRef = new ResourceEnvRefImpl();
                current = getCurrentUNode();
                resourceEnvRef.setParentUNode(current);
                resourceEnvRef.setCurrentUNode(resourceEnvRef);
                this.setCurrentUNode(resourceEnvRef);
                resourceEnvRef.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                resourceEnvRefList.add(resourceEnvRef);
                return;
            }
            if (localName.equals("query")) {
                QueryImpl query = new QueryImpl();
                current = getCurrentUNode();
                query.setParentUNode(current);
                query.setCurrentUNode(query);
                this.setCurrentUNode(query);
                query.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                queryList.add(query);
                return;
            }
        }
    }

    public void endElement(String namespaceURI, String localName,
                           String qName)
        throws SAXException {

        Unmarshallable current = getCurrentUNode();
        if (current != this) {
            current.endElement(namespaceURI, localName, qName);
            return;
        }

        Unmarshallable parent = getCurrentUNode().getParentUNode();
        if (parent != null) {
            parent.setCurrentUNode(parent);
        }
    }

    public void characters(char[] ch, int start, int len)
        throws SAXException {

        // Feed this to the correct ContentHandler
        Unmarshallable current = getCurrentUNode();
        if (current != this) {
            current.characters(ch, start, len);
            return;
        }

        String text = new String(ch, start, len);
        text = text.trim();
    }

}
