/**
 * This class was generated from a set of XML constraints
 *   by the Enhydra Zeus XML Data Binding Framework. All
 *   source code in this file is constructed specifically
 *   to work with other Zeus-generated classes. If you
 *   modify this file by hand, you run the risk of breaking
 *   this interoperation, as well as introducing errors in
 *   source code compilation.
 *
 * * * * * MODIFY THIS FILE AT YOUR OWN RISK * * * * *
 *
 * To find out more about the Enhydra Zeus framework, you
 *   can point your browser at <http://zeus.enhydra.org>
 *   where you can download releases, join and discuss Zeus
 *   on user and developer mailing lists, and access source
 *   code. Please report any bugs through that website.
 */
package org.objectweb.jonas_ejb.deployment.xml;

// Global Implementation Import Statements
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Reader;
import java.io.Writer;
import org.xml.sax.Attributes;
import org.xml.sax.EntityResolver;
import org.xml.sax.ErrorHandler;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.XMLReaderFactory;

// Local Implementation Import Statements
import java.util.Iterator;
import java.util.List;
import java.util.LinkedList;

public class JdbcMappingImpl extends DefaultHandler implements Unmarshallable, JdbcMapping {

    private JndiName jndiName;
    private JdbcTableName jdbcTableName;
    private List cmpFieldJdbcMappingList;
    private List finderMethodJdbcMappingList;

    /** The current node in unmarshalling */
    private Unmarshallable zeus_currentUNode;

    /** The parent node in unmarshalling */
    private Unmarshallable zeus_parentUNode;

    /** Whether this node has been handled */
    private boolean zeus_thisNodeHandled = false;

    /** The EntityResolver for SAX parsing to use */
    private static EntityResolver entityResolver;

    /** The ErrorHandler for SAX parsing to use */
    private static ErrorHandler errorHandler;

    public JdbcMappingImpl() {
        cmpFieldJdbcMappingList = new LinkedList();
        finderMethodJdbcMappingList = new LinkedList();
    }

    public JndiName getJndiName() {
        return jndiName;
    }

    public void setJndiName(JndiName jndiName) {
        this.jndiName = jndiName;
    }

    public JdbcTableName getJdbcTableName() {
        return jdbcTableName;
    }

    public void setJdbcTableName(JdbcTableName jdbcTableName) {
        this.jdbcTableName = jdbcTableName;
    }

    public List getCmpFieldJdbcMappingList() {
        return cmpFieldJdbcMappingList;
    }

    public void setCmpFieldJdbcMappingList(List cmpFieldJdbcMappingList) {
        this.cmpFieldJdbcMappingList = cmpFieldJdbcMappingList;
    }

    public void addCmpFieldJdbcMapping(CmpFieldJdbcMapping cmpFieldJdbcMapping) {
        cmpFieldJdbcMappingList.add(cmpFieldJdbcMapping);
    }

    public void removeCmpFieldJdbcMapping(CmpFieldJdbcMapping cmpFieldJdbcMapping) {
        cmpFieldJdbcMappingList.remove(cmpFieldJdbcMapping);
    }

    public List getFinderMethodJdbcMappingList() {
        return finderMethodJdbcMappingList;
    }

    public void setFinderMethodJdbcMappingList(List finderMethodJdbcMappingList) {
        this.finderMethodJdbcMappingList = finderMethodJdbcMappingList;
    }

    public void addFinderMethodJdbcMapping(FinderMethodJdbcMapping finderMethodJdbcMapping) {
        finderMethodJdbcMappingList.add(finderMethodJdbcMapping);
    }

    public void removeFinderMethodJdbcMapping(FinderMethodJdbcMapping finderMethodJdbcMapping) {
        finderMethodJdbcMappingList.remove(finderMethodJdbcMapping);
    }

    public void marshal(File file) throws IOException {
        // Delegate to the marshal(Writer) method
        marshal(new FileWriter(file));
    }

    public void marshal(OutputStream outputStream) throws IOException {
        // Delegate to the marshal(Writer) method
        marshal(new OutputStreamWriter(outputStream));
    }

    public void marshal(Writer writer) throws IOException {
        // Write out the XML declaration
        writer.write("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n\n");

        // Now start the recursive writing
        writeXMLRepresentation(writer, "");

        // Close up
        writer.flush();
        writer.close();
    }

    protected void writeXMLRepresentation(Writer writer,
                                          String indent)
        throws IOException {

        writer.write(indent);
        writer.write("<jdbc-mapping");

        // Handle attributes (if needed)
        writer.write(">");
        writer.write("\n");

        // Handle child elements
        if (jndiName != null) {
            ((JndiNameImpl)jndiName).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (jdbcTableName != null) {
            ((JdbcTableNameImpl)jdbcTableName).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        for (Iterator i=cmpFieldJdbcMappingList.iterator(); i.hasNext(); ) {
            CmpFieldJdbcMappingImpl cmpFieldJdbcMapping = (CmpFieldJdbcMappingImpl)i.next();
            cmpFieldJdbcMapping.writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }
        for (Iterator i=finderMethodJdbcMappingList.iterator(); i.hasNext(); ) {
            FinderMethodJdbcMappingImpl finderMethodJdbcMapping = (FinderMethodJdbcMappingImpl)i.next();
            finderMethodJdbcMapping.writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }
        writer.write(indent);
        writer.write("</jdbc-mapping>\n");
    }

    private String escapeAttributeValue(String attributeValue) {
        String returnValue = attributeValue;
        for (int i = 0; i < returnValue.length(); i++) {
            char ch = returnValue.charAt(i);
            if (ch == '"') {
                returnValue = new StringBuffer()
                    .append(returnValue.substring(0, i))
                    .append("&quot;")
                    .append(returnValue.substring(i+1))
                    .toString();
            }
        }
        return returnValue;
    }

    /**
     * <p>
     *  This sets a SAX <code>EntityResolver</code> for this unmarshalling process.
     * </p>
     *
     * @param resolver the entity resolver to use.
     */
    public static void setEntityResolver(EntityResolver resolver) {
        entityResolver = resolver;
    }

    /**
     * <p>
     *  This sets a SAX <code>ErrorHandler</code> for this unmarshalling process.
     * </p>
     *
     * @param handler the entity resolver to use.
     */
    public static void setErrorHandler(ErrorHandler handler) {
        errorHandler = handler;
    }

    public static JdbcMapping unmarshal(File file) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new FileReader(file));
    }

    public static JdbcMapping unmarshal(File file, boolean validate) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new FileReader(file), validate);
    }

    public static JdbcMapping unmarshal(InputStream inputStream) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new InputStreamReader(inputStream));
    }

    public static JdbcMapping unmarshal(InputStream inputStream, boolean validate) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new InputStreamReader(inputStream), validate);
    }

    public static JdbcMapping unmarshal(Reader reader) throws IOException {
        // Delegate with default validation value
        return unmarshal(reader, false);
    }

    public static JdbcMapping unmarshal(Reader reader, boolean validate) throws IOException {
        JdbcMappingImpl jdbcMapping = new JdbcMappingImpl();
        jdbcMapping.setCurrentUNode(jdbcMapping);
        jdbcMapping.setParentUNode(null);
        // Load the XML parser
        XMLReader parser = null;
        String parserClass = System.getProperty("org.xml.sax.driver",
            "org.apache.xerces.parsers.SAXParser");
        try {
            parser = XMLReaderFactory.createXMLReader(parserClass);

            // Set entity resolver, if needed
            if (entityResolver != null) {
                parser.setEntityResolver(entityResolver);
            }

            // Set error handler, if needed
            if (errorHandler != null) {
                parser.setErrorHandler(errorHandler);
            }

            // Register content handler
            parser.setContentHandler(jdbcMapping);
        } catch (SAXException e) {
            throw new IOException("Could not load XML parser: " + 
                e.getMessage());
        }

        InputSource inputSource = new InputSource(reader);
        try {
            parser.setFeature("http://xml.org/sax/features/validation", new Boolean(validate).booleanValue());
            parser.parse(inputSource);
        } catch (SAXException e) {
            throw new IOException("Error parsing XML document: " + 
                e.getMessage());
        }

        // Return the resultant object
        return jdbcMapping;
    }

    public Unmarshallable getParentUNode() {
        return zeus_parentUNode;
    }

    public void setParentUNode(Unmarshallable parentUNode) {
        this.zeus_parentUNode = parentUNode;
    }

    public Unmarshallable getCurrentUNode() {
        return zeus_currentUNode;
    }

    public void setCurrentUNode(Unmarshallable currentUNode) {
        this.zeus_currentUNode = currentUNode;
    }

    public void startElement(String namespaceURI, String localName,
                             String qName, Attributes atts)
        throws SAXException {

        // Feed this to the correct ContentHandler
        Unmarshallable current = getCurrentUNode();
        if (current != this) {
            current.startElement(namespaceURI, localName, qName, atts);
            return;
        }

        // See if we handle, or we delegate
        if ((localName.equals("jdbc-mapping")) && (!zeus_thisNodeHandled)) {
            // Handle ourselves
            for (int i=0, len=atts.getLength(); i<len; i++) {
                String attName= atts.getLocalName(i);
                String attValue = atts.getValue(i);
            }
            zeus_thisNodeHandled = true;
            return;
        } else {
            // Delegate handling
            if (localName.equals("jndi-name")) {
                JndiNameImpl jndiName = new JndiNameImpl();
                current = getCurrentUNode();
                jndiName.setParentUNode(current);
                jndiName.setCurrentUNode(jndiName);
                this.setCurrentUNode(jndiName);
                jndiName.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.jndiName = jndiName;
                return;
            }
            if (localName.equals("jdbc-table-name")) {
                JdbcTableNameImpl jdbcTableName = new JdbcTableNameImpl();
                current = getCurrentUNode();
                jdbcTableName.setParentUNode(current);
                jdbcTableName.setCurrentUNode(jdbcTableName);
                this.setCurrentUNode(jdbcTableName);
                jdbcTableName.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.jdbcTableName = jdbcTableName;
                return;
            }
            if (localName.equals("cmp-field-jdbc-mapping")) {
                CmpFieldJdbcMappingImpl cmpFieldJdbcMapping = new CmpFieldJdbcMappingImpl();
                current = getCurrentUNode();
                cmpFieldJdbcMapping.setParentUNode(current);
                cmpFieldJdbcMapping.setCurrentUNode(cmpFieldJdbcMapping);
                this.setCurrentUNode(cmpFieldJdbcMapping);
                cmpFieldJdbcMapping.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                cmpFieldJdbcMappingList.add(cmpFieldJdbcMapping);
                return;
            }
            if (localName.equals("finder-method-jdbc-mapping")) {
                FinderMethodJdbcMappingImpl finderMethodJdbcMapping = new FinderMethodJdbcMappingImpl();
                current = getCurrentUNode();
                finderMethodJdbcMapping.setParentUNode(current);
                finderMethodJdbcMapping.setCurrentUNode(finderMethodJdbcMapping);
                this.setCurrentUNode(finderMethodJdbcMapping);
                finderMethodJdbcMapping.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                finderMethodJdbcMappingList.add(finderMethodJdbcMapping);
                return;
            }
        }
    }

    public void endElement(String namespaceURI, String localName,
                           String qName)
        throws SAXException {

        Unmarshallable current = getCurrentUNode();
        if (current != this) {
            current.endElement(namespaceURI, localName, qName);
            return;
        }

        Unmarshallable parent = getCurrentUNode().getParentUNode();
        if (parent != null) {
            parent.setCurrentUNode(parent);
        }
    }

    public void characters(char[] ch, int start, int len)
        throws SAXException {

        // Feed this to the correct ContentHandler
        Unmarshallable current = getCurrentUNode();
        if (current != this) {
            current.characters(ch, start, len);
            return;
        }

        String text = new String(ch, start, len);
        text = text.trim();
    }

}
