/**
 * This class was generated from a set of XML constraints
 *   by the Enhydra Zeus XML Data Binding Framework. All
 *   source code in this file is constructed specifically
 *   to work with other Zeus-generated classes. If you
 *   modify this file by hand, you run the risk of breaking
 *   this interoperation, as well as introducing errors in
 *   source code compilation.
 *
 * * * * * MODIFY THIS FILE AT YOUR OWN RISK * * * * *
 *
 * To find out more about the Enhydra Zeus framework, you
 *   can point your browser at <http://zeus.enhydra.org>
 *   where you can download releases, join and discuss Zeus
 *   on user and developer mailing lists, and access source
 *   code. Please report any bugs through that website.
 */
package org.objectweb.jonas_ejb.deployment.xml;

// Global Implementation Import Statements
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Reader;
import java.io.Writer;
import org.xml.sax.Attributes;
import org.xml.sax.EntityResolver;
import org.xml.sax.ErrorHandler;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.XMLReaderFactory;

public class EjbJarImpl extends DefaultHandler implements Unmarshallable, EjbJar {

    private Description description;
    private DisplayName displayName;
    private SmallIcon smallIcon;
    private LargeIcon largeIcon;
    private EnterpriseBeans enterpriseBeans;
    private Relationships relationships;
    private AssemblyDescriptor assemblyDescriptor;
    private EjbClientJar ejbClientJar;
    private String id;
    private boolean zeus_idSet;

    /** The current node in unmarshalling */
    private Unmarshallable zeus_currentUNode;

    /** The parent node in unmarshalling */
    private Unmarshallable zeus_parentUNode;

    /** Whether this node has been handled */
    private boolean zeus_thisNodeHandled = false;

    /** The EntityResolver for SAX parsing to use */
    private static EntityResolver entityResolver;

    /** The ErrorHandler for SAX parsing to use */
    private static ErrorHandler errorHandler;

    public EjbJarImpl() {
        zeus_idSet = false;
    }

    public Description getDescription() {
        return description;
    }

    public void setDescription(Description description) {
        this.description = description;
    }

    public DisplayName getDisplayName() {
        return displayName;
    }

    public void setDisplayName(DisplayName displayName) {
        this.displayName = displayName;
    }

    public SmallIcon getSmallIcon() {
        return smallIcon;
    }

    public void setSmallIcon(SmallIcon smallIcon) {
        this.smallIcon = smallIcon;
    }

    public LargeIcon getLargeIcon() {
        return largeIcon;
    }

    public void setLargeIcon(LargeIcon largeIcon) {
        this.largeIcon = largeIcon;
    }

    public EnterpriseBeans getEnterpriseBeans() {
        return enterpriseBeans;
    }

    public void setEnterpriseBeans(EnterpriseBeans enterpriseBeans) {
        this.enterpriseBeans = enterpriseBeans;
    }

    public Relationships getRelationships() {
        return relationships;
    }

    public void setRelationships(Relationships relationships) {
        this.relationships = relationships;
    }

    public AssemblyDescriptor getAssemblyDescriptor() {
        return assemblyDescriptor;
    }

    public void setAssemblyDescriptor(AssemblyDescriptor assemblyDescriptor) {
        this.assemblyDescriptor = assemblyDescriptor;
    }

    public EjbClientJar getEjbClientJar() {
        return ejbClientJar;
    }

    public void setEjbClientJar(EjbClientJar ejbClientJar) {
        this.ejbClientJar = ejbClientJar;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
        zeus_idSet = true;
    }

    public void marshal(File file) throws IOException {
        // Delegate to the marshal(Writer) method
        marshal(new FileWriter(file));
    }

    public void marshal(OutputStream outputStream) throws IOException {
        // Delegate to the marshal(Writer) method
        marshal(new OutputStreamWriter(outputStream));
    }

    public void marshal(Writer writer) throws IOException {
        // Write out the XML declaration
        writer.write("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n\n");

        // Now start the recursive writing
        writeXMLRepresentation(writer, "");

        // Close up
        writer.flush();
        writer.close();
    }

    protected void writeXMLRepresentation(Writer writer,
                                          String indent)
        throws IOException {

        writer.write(indent);
        writer.write("<ejb-jar");

        // Handle attributes (if needed)
        if (zeus_idSet) {
            writer.write(" id=\"");
            writer.write(escapeAttributeValue(id));
            writer.write("\"");
        }
        writer.write(">");
        writer.write("\n");

        // Handle child elements
        if (description != null) {
            ((DescriptionImpl)description).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (displayName != null) {
            ((DisplayNameImpl)displayName).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (smallIcon != null) {
            ((SmallIconImpl)smallIcon).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (largeIcon != null) {
            ((LargeIconImpl)largeIcon).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (enterpriseBeans != null) {
            ((EnterpriseBeansImpl)enterpriseBeans).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (relationships != null) {
            ((RelationshipsImpl)relationships).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (assemblyDescriptor != null) {
            ((AssemblyDescriptorImpl)assemblyDescriptor).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        if (ejbClientJar != null) {
            ((EjbClientJarImpl)ejbClientJar).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        writer.write(indent);
        writer.write("</ejb-jar>\n");
    }

    private String escapeAttributeValue(String attributeValue) {
        String returnValue = attributeValue;
        for (int i = 0; i < returnValue.length(); i++) {
            char ch = returnValue.charAt(i);
            if (ch == '"') {
                returnValue = new StringBuffer()
                    .append(returnValue.substring(0, i))
                    .append("&quot;")
                    .append(returnValue.substring(i+1))
                    .toString();
            }
        }
        return returnValue;
    }

    /**
     * <p>
     *  This sets a SAX <code>EntityResolver</code> for this unmarshalling process.
     * </p>
     *
     * @param resolver the entity resolver to use.
     */
    public static void setEntityResolver(EntityResolver resolver) {
        entityResolver = resolver;
    }

    /**
     * <p>
     *  This sets a SAX <code>ErrorHandler</code> for this unmarshalling process.
     * </p>
     *
     * @param handler the entity resolver to use.
     */
    public static void setErrorHandler(ErrorHandler handler) {
        errorHandler = handler;
    }

    public static EjbJar unmarshal(File file) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new FileReader(file));
    }

    public static EjbJar unmarshal(File file, boolean validate) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new FileReader(file), validate);
    }

    public static EjbJar unmarshal(InputStream inputStream) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new InputStreamReader(inputStream));
    }

    public static EjbJar unmarshal(InputStream inputStream, boolean validate) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new InputStreamReader(inputStream), validate);
    }

    public static EjbJar unmarshal(Reader reader) throws IOException {
        // Delegate with default validation value
        return unmarshal(reader, false);
    }

    public static EjbJar unmarshal(Reader reader, boolean validate) throws IOException {
        EjbJarImpl ejbJar = new EjbJarImpl();
        ejbJar.setCurrentUNode(ejbJar);
        ejbJar.setParentUNode(null);
        // Load the XML parser
        XMLReader parser = null;
        String parserClass = System.getProperty("org.xml.sax.driver",
            "org.apache.xerces.parsers.SAXParser");
        try {
            parser = XMLReaderFactory.createXMLReader(parserClass);

            // Set entity resolver, if needed
            if (entityResolver != null) {
                parser.setEntityResolver(entityResolver);
            }

            // Set error handler, if needed
            if (errorHandler != null) {
                parser.setErrorHandler(errorHandler);
            }

            // Register content handler
            parser.setContentHandler(ejbJar);
        } catch (SAXException e) {
            throw new IOException("Could not load XML parser: " + 
                e.getMessage());
        }

        InputSource inputSource = new InputSource(reader);
        try {
            parser.setFeature("http://xml.org/sax/features/validation", new Boolean(validate).booleanValue());
            parser.parse(inputSource);
        } catch (SAXException e) {
            throw new IOException("Error parsing XML document: " + 
                e.getMessage());
        }

        // Return the resultant object
        return ejbJar;
    }

    public Unmarshallable getParentUNode() {
        return zeus_parentUNode;
    }

    public void setParentUNode(Unmarshallable parentUNode) {
        this.zeus_parentUNode = parentUNode;
    }

    public Unmarshallable getCurrentUNode() {
        return zeus_currentUNode;
    }

    public void setCurrentUNode(Unmarshallable currentUNode) {
        this.zeus_currentUNode = currentUNode;
    }

    public void startElement(String namespaceURI, String localName,
                             String qName, Attributes atts)
        throws SAXException {

        // Feed this to the correct ContentHandler
        Unmarshallable current = getCurrentUNode();
        if (current != this) {
            current.startElement(namespaceURI, localName, qName, atts);
            return;
        }

        // See if we handle, or we delegate
        if ((localName.equals("ejb-jar")) && (!zeus_thisNodeHandled)) {
            // Handle ourselves
            for (int i=0, len=atts.getLength(); i<len; i++) {
                String attName= atts.getLocalName(i);
                String attValue = atts.getValue(i);
                if (attName.equals("id")) {
                    setId(attValue);
                }
            }
            zeus_thisNodeHandled = true;
            return;
        } else {
            // Delegate handling
            if (localName.equals("description")) {
                DescriptionImpl description = new DescriptionImpl();
                current = getCurrentUNode();
                description.setParentUNode(current);
                description.setCurrentUNode(description);
                this.setCurrentUNode(description);
                description.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.description = description;
                return;
            }
            if (localName.equals("display-name")) {
                DisplayNameImpl displayName = new DisplayNameImpl();
                current = getCurrentUNode();
                displayName.setParentUNode(current);
                displayName.setCurrentUNode(displayName);
                this.setCurrentUNode(displayName);
                displayName.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.displayName = displayName;
                return;
            }
            if (localName.equals("small-icon")) {
                SmallIconImpl smallIcon = new SmallIconImpl();
                current = getCurrentUNode();
                smallIcon.setParentUNode(current);
                smallIcon.setCurrentUNode(smallIcon);
                this.setCurrentUNode(smallIcon);
                smallIcon.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.smallIcon = smallIcon;
                return;
            }
            if (localName.equals("large-icon")) {
                LargeIconImpl largeIcon = new LargeIconImpl();
                current = getCurrentUNode();
                largeIcon.setParentUNode(current);
                largeIcon.setCurrentUNode(largeIcon);
                this.setCurrentUNode(largeIcon);
                largeIcon.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.largeIcon = largeIcon;
                return;
            }
            if (localName.equals("enterprise-beans")) {
                EnterpriseBeansImpl enterpriseBeans = new EnterpriseBeansImpl();
                current = getCurrentUNode();
                enterpriseBeans.setParentUNode(current);
                enterpriseBeans.setCurrentUNode(enterpriseBeans);
                this.setCurrentUNode(enterpriseBeans);
                enterpriseBeans.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.enterpriseBeans = enterpriseBeans;
                return;
            }
            if (localName.equals("relationships")) {
                RelationshipsImpl relationships = new RelationshipsImpl();
                current = getCurrentUNode();
                relationships.setParentUNode(current);
                relationships.setCurrentUNode(relationships);
                this.setCurrentUNode(relationships);
                relationships.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.relationships = relationships;
                return;
            }
            if (localName.equals("assembly-descriptor")) {
                AssemblyDescriptorImpl assemblyDescriptor = new AssemblyDescriptorImpl();
                current = getCurrentUNode();
                assemblyDescriptor.setParentUNode(current);
                assemblyDescriptor.setCurrentUNode(assemblyDescriptor);
                this.setCurrentUNode(assemblyDescriptor);
                assemblyDescriptor.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.assemblyDescriptor = assemblyDescriptor;
                return;
            }
            if (localName.equals("ejb-client-jar")) {
                EjbClientJarImpl ejbClientJar = new EjbClientJarImpl();
                current = getCurrentUNode();
                ejbClientJar.setParentUNode(current);
                ejbClientJar.setCurrentUNode(ejbClientJar);
                this.setCurrentUNode(ejbClientJar);
                ejbClientJar.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.ejbClientJar = ejbClientJar;
                return;
            }
        }
    }

    public void endElement(String namespaceURI, String localName,
                           String qName)
        throws SAXException {

        Unmarshallable current = getCurrentUNode();
        if (current != this) {
            current.endElement(namespaceURI, localName, qName);
            return;
        }

        Unmarshallable parent = getCurrentUNode().getParentUNode();
        if (parent != null) {
            parent.setCurrentUNode(parent);
        }
    }

    public void characters(char[] ch, int start, int len)
        throws SAXException {

        // Feed this to the correct ContentHandler
        Unmarshallable current = getCurrentUNode();
        if (current != this) {
            current.characters(ch, start, len);
            return;
        }

        String text = new String(ch, start, len);
        text = text.trim();
    }

}
